cdac.medinfo.sdk.hl7282.baselibs.segments

## Class RF1

- java.lang.Object
- - cdac.medinfo.sdk.hl7282.baselibs.segments.Segment
  - - cdac.medinfo.sdk.hl7282.baselibs.segments.RF1

- All Implemented Interfaces:
    ISegment

      public class RF1
      extends Segment

  RF1 - Referral Information Segment.

  This segment represents information that may be useful when sending referrals from the referring provider to the referred-to provider

  Represents an HL7 RF1 message segment. This segment has the following fields:

  RF1-1: Referral Status (CWE)Optional
  RF1-2: Referral Priority (CWE)Optional
  RF1-3: Referral Type (CWE)Optional
  RF1-4: Referral Disposition (CWE)Optional
  RF1-5: Referral Category (CWE)Optional
  RF1-6: Originating Referral Identifier (EI)Required
  RF1-7: Effective Date (DTM)Optional
  RF1-8: Expiration Date (DTM)Optional
  RF1-9: Process Date (DTM)Optional
  RF1-10: Referral Reason (CWE)Optional
  RF1-11: External Referral Identifier (EI)Optional
  RF1-12: Referral Documentation Completion Status (CWE)Optional
  RF1-13: Planned Treatment Stop Date (DTM)Optional
  RF1-14: Referral Reason Text (ST)Optional
  RF1-15: Number of Authorized Treatments/Units (CQ)Optional
  RF1-16: Number of Used Treatments/Units (CQ)Optional
  RF1-17: Number of Schedule Treatments/Units (CQ)Optional
  RF1-18: Remaining Benefit Amount (MO)Optional
  RF1-19: Authorized Provider (XON)Optional
  RF1-20: Authorized Health Professional (XCN)Optional
  RF1-21: Source Text (ST)Optional
  RF1-22: Source Date (DTM)Optional
  RF1-23: Source Phone (XTN)Optional
  RF1-24: Comment (ST)Optional
  RF1-25: Action Code (ID)Optional

  This class provides mechanism to validate message against HL7 v 2.8.2 standard. The class provides accessors & mutators for the elements mentioned above. The class has validate method which validates Message against HL7 v 2.8.2 standard.

  User can also create Segment through `SegmentFactory`

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `RF1()` Constucts the RF1 segment.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addExternalReferralIdentifier(EI objtempExternalReferralIdentifier)` Sets the External Referral Identifier.
    `void` | `addExternalReferralIdentifier(java.lang.String strEntityIdentifier, java.lang.String strNamespaceId, java.lang.String strUniversalId, java.lang.String strUniversalIdType)` Set the External Referral Identifier.
    `void` | `addReferralDisposition(CWE objtempReferralDisposition)` Set the Referral Disposition.
    `void` | `addReferralDisposition(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Referral Disposition.
    `void` | `addReferralReason(CWE objtempReferralReason)` Set the Referral Reason.
    `void` | `addReferralReason(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Referral Reason.
    `ID` | `getActionCode()` Retrieves the Action Code.
    `XCN` | `getAuthorizedHealthProfessional()` Retrieves the Authorized Health Professional.
    `XON` | `getAuthorizedProvider()` Retrieves the Authorized Provider.
    `ST` | `getComment()` Retrieves the Comment.
    `DTM` | `getEffectiveDate()` Retrieves the Effective Date.
    `DTM` | `getExpirationDate()` Retrieves the Expiration Date.
    `ISingleCollection<EI>` | `getExternalReferralIdentifier()` Retrieves the External Referral Identifier.
    `CQ` | `getNumberOfAuthorizedTreatmentsUnits()` Retrieves the Number of Authorized Treatments/Units.
    `CQ` | `getNumberOfScheduleTreatmentsUnits()` Retrieves the Number of Schedule Treatments/Units.
    `CQ` | `getNumberOfUsedTreatmentsUnits()` Retrieves the Number of Used Treatments/Units.
    `EI` | `getOriginatingReferralIdentifier()` Retrieves the Originating Referral Identifier.
    `DTM` | `getPlannedTreatmentStopDate()` Retrieves the Planned Treatment Stop Date.
    `DTM` | `getProcessDate()` Retrieves the Process Date.
    `CWE` | `getReferralCategory()` Retrieves the Referral Category.
    `ISingleCollection<CWE>` | `getReferralDisposition()` Retrieves the Referral Disposition.
    `CWE` | `getReferralDocumentationCompletionStatus()` Retrieves the Referral Documentation Completion Status.
    `CWE` | `getReferralPriority()` Retrieves the Referral Priority.
    `ISingleCollection<CWE>` | `getReferralReason()` Retrieves the Referral Reason.
    `ST` | `getReferralReasonText()` Retrieves the Referral Reason Text.
    `CWE` | `getReferralStatus()` Retrieves the Referral Status.
    `CWE` | `getReferralType()` Retrieves the Referral Type.
    `MO` | `getRemainingBenefitAmount()` Retrieves the Remaining Benefit Amount.
    `DTM` | `getSourceDate()` Retrieves the Source Date.
    `XTN` | `getSourcePhone()` Retrieves the Source Phone.
    `ST` | `getSourceText()` Retrieves the Source Text.
    `void` | `setActionCode(ID objActionCode)` Set the Action Code.
    `void` | `setActionCode(java.lang.String strActionCode)` Set the Action Code.
    `void` | `setAuthorizedHealthProfessional(java.lang.String strIDNumber, FN objFamilyName, java.lang.String strGivenName, java.lang.String strSecondAndFurtherGivenNamesOrInitialsThereof, java.lang.String strSuffix, java.lang.String strPrefix, CWE objSourceTable, HD objAssigningAuthority, java.lang.String strNameTypeCode, java.lang.String strIdentifierCheckDigit, java.lang.String strCheckDigitScheme, java.lang.String strIdentifierTypeCode, HD objAssigningFacility, java.lang.String strNameRepresentationCode, CWE objNameContext, java.lang.String strNameAssemblyOrder, java.lang.String strEffectiveDate, java.lang.String strExpirationDate, java.lang.String strProfessionalSuffix, CWE objAssigningJurisdiction, CWE objAssigningAgencyOrDepratment, java.lang.String strSecurityCheck, java.lang.String strSecurityCheckScheme)` Set the Authorized Health Professional.
    `void` | `setAuthorizedHealthProfessional(XCN objAuthorizedHealthProfessional)` Sets the Authorized Health Professional.
    `void` | `setAuthorizedProvider(java.lang.String strOrganizationName, CWE objOrganizationNameTypeCode, HD objAssigningAuthority, java.lang.String strIdentifierTypeCode, HD objAssigningFacility, java.lang.String strNameRepresentationCode, java.lang.String strOrganizationIdentifier)` Set the Authorized Provider.
    `void` | `setAuthorizedProvider(XON objAuthorizedProvider)` Ses the Authorized Provider.
    `void` | `setComment(ST objComment)` Set the Comment.
    `void` | `setComment(java.lang.String strComment)` Set the Comment.
    `void` | `setEffectiveDate(DTM objeffectiveDate)` Set the Effective Date.
    `void` | `setEffectiveDate(java.lang.String strTime)` Set the Effective Date.
    `void` | `setExpirationDate(DTM objexpirationDate)` Set the Expiration Date.
    `void` | `setExpirationDate(java.lang.String strTime)` Set the Expiration Date.
    `void` | `setExternalReferralIdentifier(ISingleCollection<EI> objExternalReferralIdentifierList)` Set the External Referral Identifier list.
    `void` | `setNumberOfAuthorizedTreatmentsUnits(CQ objNumberOfAuthorizedTreatmentsUnits)` Set the Number of Authorized Treatments/Units.
    `void` | `setNumberOfAuthorizedTreatmentsUnits(java.lang.String strQuantity, CWE objUnits)` Set the Number of Authorized Treatments/Units.
    `void` | `setNumberOfScheduleTreatmentsUnits(CQ objNumberOfScheduleTreatmentsUnits)` Set the Number of Schedule Treatments/Units.
    `void` | `setNumberOfScheduleTreatmentsUnits(java.lang.String strQuantity, CWE objUnits)` Set the Number of Schedule Treatments/Units.
    `void` | `setNumberOfUsedTreatmentsUnits(CQ objNumberOfUsedTreatmentsUnits)` Set the Number of Used Treatments/Units.
    `void` | `setNumberOfUsedTreatmentsUnits(java.lang.String strQuantity, CWE objUnits)` Set the Number of Used Treatments/Units.
    `void` | `setOriginatingReferralIdentifier(EI objoriginatingReferralIdentifier)` Set the Originating Referral Identifier.
    `void` | `setOriginatingReferralIdentifier(java.lang.String strEntityIdentifier, java.lang.String strNamespaceId, java.lang.String strUniversalId, java.lang.String strUniversalIdType)` Set the Originating Referral Identifier.
    `void` | `setPlannedTreatmentStopDate(DTM objPlannedTreatmentStopDate)` Set the Planned Treatment Stop Date.
    `void` | `setPlannedTreatmentStopDate(java.lang.String strPlannedTreatmentStopDate)` Set the Planned Treatment Stop Date.
    `void` | `setProcessDate(DTM objprocessDate)` Set the Process Date.
    `void` | `setProcessDate(java.lang.String strTime)` Set the Process Date.
    `void` | `setReferralCategory(CWE objreferralCategory)` Set the Referral Category.
    `void` | `setReferralCategory(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Referral Category.
    `void` | `setReferralDisposition(ISingleCollection<CWE> objReferralDispositionList)` Set the Referral Disposition list.
    `void` | `setReferralDocumentationCompletionStatus(CWE objReferralDocumentationCompletionStatus)` Set the Referral Documentation Completion Status.
    `void` | `setReferralDocumentationCompletionStatus(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Referral Documentation Completion Status.
    `void` | `setReferralPriority(CWE objreferralPriority)` Set the Referral Priority.
    `void` | `setReferralPriority(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Referral Priority.
    `void` | `setReferralReason(ISingleCollection<CWE> objReferralReasonList)` Set the Referral Reason list.
    `void` | `setReferralReasonText(ST ReferralReasonText)` Set the Referral Reason Text.
    `void` | `setReferralReasonText(java.lang.String strAccidentDecription)` Set the Referral Reason Text.
    `void` | `setReferralStatus(CWE objreferralStatus)` Set the Referral Status.
    `void` | `setReferralStatus(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Referral Status.
    `void` | `setReferralType(CWE objreferralType)` Set the Referral Type.
    `void` | `setReferralType(java.lang.String strIdentifier, java.lang.String strText, java.lang.String strNameOfCodingSystem, java.lang.String strAlternateIdentifier, java.lang.String strAlternateText, java.lang.String strNameOfAlternateCodingSystem, java.lang.String strCodingSystemVersionID, java.lang.String strAlternateCodingSystemVersionId, java.lang.String strOriginalText, java.lang.String strSecondAlternateIdentifier, java.lang.String strSecondAlternateText, java.lang.String strNameofSecondAlternateCodingSystem, java.lang.String strSecondAlternateCodingSystemVersionID, java.lang.String strCodingSystemOID, java.lang.String strValueSetOID, java.lang.String strValueSetVersionID, java.lang.String strAlternateCodingSystemOID, java.lang.String strAlternateValueSetOID, java.lang.String strAlternateValueSetVersionID, java.lang.String strSecondAlternateCodingSystemOID, java.lang.String strSecondAlternateValueSetOID, java.lang.String strSecondAlternateValueSetVersionID)` Set the Referral Type.
    `void` | `setRemainingBenefitAmount(MO objRemainingBenefitAmount)` Set the Remaining Benefit Amount.
    `void` | `setRemainingBenefitAmount(java.lang.String strQuantity, java.lang.String strDenomination)` Set the Remaining Benefit Amount.
    `void` | `setSourceDate(DTM objSourceDate)` Sets the Source Date.
    `void` | `setSourceDate(java.lang.String strDateTimePlannedEvent)` Set the Source Date.
    `void` | `setSourcePhone(java.lang.String strTeleCommunicationUseCode, java.lang.String strTeleCommunicationEquipmentType, java.lang.String strCommuinicationAddress, java.lang.String strCountryCode, java.lang.String strAreaCityCode, java.lang.String strLocalNumber, java.lang.String strExtension, java.lang.String strAnyText, java.lang.String strExtensionPrefix, java.lang.String strSpeedDialCode, java.lang.String strUnformattedTelephoneNumber, java.lang.String strEffectiveStartDate, java.lang.String strExpirationDate, CWE objExpirationReason, CWE objProtectionCode, EI objSharedTelecommunicationIdentifier, java.lang.String strPreferenceOrder)` Set the Source Phone.
    `void` | `setSourcePhone(XTN objXtn)` Sets the Source Phone.
    `void` | `setSourceText(ST objSourceText)` Set the Source Text.
    `void` | `setSourceText(java.lang.String strSourceText)` Set the Source Text.
    `boolean` | `validate()` Validates HL7 Message objects .

    - ### Methods inherited from class cdac.medinfo.sdk.hl7282.baselibs.segments.Segment

      `addUnRecognizedField, dumpSegment, getFields, getName, getUnrecognizedFields, moveToNextSegment, parse, removeDataElement, removeDataElement, serialize, setName, setUnRecognizedField, updateDataElement, updateDataElement, writeToXML`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### RF1

          public RF1()

      Constucts the RF1 segment.

  - ### Method Detail

    - #### getEffectiveDate

          public DTM getEffectiveDate()

      Retrieves the Effective Date. This field specify the date on which the referral is effective.
      Returns:
        DTM - effectiveDate

    - #### getExpirationDate

          public DTM getExpirationDate()

      Retrieves the Expiration Date.
      Returns:
        DTM - expirationDate

    - #### getExternalReferralIdentifier

          public ISingleCollection<EI> getExternalReferralIdentifier()

      Retrieves the External Referral Identifier. This field specify an external application's permanent identifier for the referral.
      Returns:
        ISingleCollection - externalReferralIdentifier

    - #### getOriginatingReferralIdentifier

          public EI getOriginatingReferralIdentifier()

      Retrieves the Originating Referral Identifier. This field specify the originating application's permanent identifier for the referral.
      Returns:
        EI - originatingReferralIdentifier

    - #### getProcessDate

          public DTM getProcessDate()

      Retrieves the Process Date. This field specify the date on which the referral originated.
      Returns:
        DTM - processDate

    - #### getReferralCategory

          public CWE getReferralCategory()

      Retrieves the Referral Category.
      Returns:
        CWE - referralCategory

    - #### getReferralDisposition

          public ISingleCollection<CWE> getReferralDisposition()

      Retrieves the Referral Disposition.
      Returns:
        ISingleCollection - referralDisposition

    - #### getReferralPriority

          public CWE getReferralPriority()

      Retrieves the Referral Priority.
      Returns:
        CWE - referralPriority

    - #### getReferralReason

          public ISingleCollection<CWE> getReferralReason()

      Retrieves the Referral Reason.
      Returns:
        ISingleCollection - referralReason

    - #### getReferralStatus

          public CWE getReferralStatus()

      Retrieves the Referral Status. This field specify the status of the referral as define by either the referred-to or the referred-by provider.
      Returns:
        CWE - referralStatus

    - #### getReferralType

          public CWE getReferralType()

      Retrieves the Referral Type.
      Returns:
        CWE - referralType

    - #### getNumberOfUsedTreatmentsUnits

          public CQ getNumberOfUsedTreatmentsUnits()

      Retrieves the Number of Used Treatments/Units. The scheduled treatments is the amount of time, in days or visits that the patient has planned treatments scheduled The duration of "days" is reserved for inpatient authorizations. The duration of "days" is reserved for inpatient authorizations.
      Returns:
        CQ - NumberOfUsedTreatmentsUnits

    - #### setNumberOfUsedTreatmentsUnits

          public void setNumberOfUsedTreatmentsUnits(java.lang.String strQuantity,
                                            CWE objUnits)

      Set the Number of Used Treatments/Units. The scheduled treatments is the amount of time, in days or visits that the patient has planned treatments scheduled The duration of "days" is reserved for inpatient authorizations. The duration of "days" is reserved for inpatient authorizations.
      Parameters:
        `strQuantity` - Use as Quantity
        `objUnits` - Use as Units

    - #### setNumberOfUsedTreatmentsUnits

          public void setNumberOfUsedTreatmentsUnits(CQ objNumberOfUsedTreatmentsUnits)

      Set the Number of Used Treatments/Units. The scheduled treatments is the amount of time, in days or visits that the patient has planned treatments scheduled The duration of "days" is reserved for inpatient authorizations. The duration of "days" is reserved for inpatient authorizations.
      Parameters:
        `objNumberOfUsedTreatmentsUnits` - Object of Number of Used Treatments/Units.

    - #### validate

          public boolean validate()
                           throws InvalidSegmentException

      Validates HL7 Message objects . Validate method checks for validation each and every segments in side the Message object against specified message Structure. Validation chcecks include optionality of segment or group. It also verifies the number of times segment or group is repeated in message. e.g {PSH} while parsing PSH segment validate method will check for its mandatory presence. [PSH] in this case validate will throw exception if one tries to enter more than one PSH segment.
      Specified by:
        `validate` in interface `ISegment`
      Overrides:
        `validate` in class `Segment`
      Returns:
        boolean - true or false.
      Throws:
        `InvalidSegmentException` - Throws when Segment Validation fails.

    - #### setEffectiveDate

          public void setEffectiveDate(java.lang.String strTime)

      Set the Effective Date. This field specify the date on which the referral is effective.
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.

    - #### setEffectiveDate

          public void setEffectiveDate(DTM objeffectiveDate)

      Set the Effective Date. This field specify the date on which the referral is effective.
      Parameters:
        `objeffectiveDate` - object of EffectiveDate

    - #### setExpirationDate

          public void setExpirationDate(java.lang.String strTime)

      Set the Expiration Date.
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.

    - #### setExpirationDate

          public void setExpirationDate(DTM objexpirationDate)

      Set the Expiration Date.
      Parameters:
        `objexpirationDate` - object of ExpirationDate

    - #### addExternalReferralIdentifier

          public void addExternalReferralIdentifier(java.lang.String strEntityIdentifier,
                                           java.lang.String strNamespaceId,
                                           java.lang.String strUniversalId,
                                           java.lang.String strUniversalIdType)

      Set the External Referral Identifier. This field specify an external application's permanent identifier for the referral.
      Parameters:
        `strEntityIdentifier` - Specifies defined by a hierarchic designator, represented by components 2 through 4. [Reference Section 2.A.33, "HD - hierarchic designator".]
        `strNamespaceId` - Specifies the HL7 identifier for the user-defined table of values for this component. [Refer to User-defined Table 0363 - Assigning authority]
        `strUniversalId` - Specifies string formatted according to the scheme defined by the component, (UID type).
        `strUniversalIdType` - Specifies the interpretation of the second component of the HD.

    - #### addExternalReferralIdentifier

          public void addExternalReferralIdentifier(EI objtempExternalReferralIdentifier)

      Sets the External Referral Identifier.
      Parameters:
        `objtempExternalReferralIdentifier` - object of ExternalReferralIdentifier

    - #### setExternalReferralIdentifier

          public void setExternalReferralIdentifier(ISingleCollection<EI> objExternalReferralIdentifierList)

      Set the External Referral Identifier list.
      Parameters:
        `objExternalReferralIdentifierList` - List of External Referral Identifier.

    - #### setOriginatingReferralIdentifier

          public void setOriginatingReferralIdentifier(java.lang.String strEntityIdentifier,
                                              java.lang.String strNamespaceId,
                                              java.lang.String strUniversalId,
                                              java.lang.String strUniversalIdType)

      Set the Originating Referral Identifier. This field specify the originating application's permanent identifier for the referral.
      Parameters:
        `strEntityIdentifier` - Specifies defined by a hierarchic designator, represented by components 2 through 4. [Reference Section 2.A.33, "HD - hierarchic designator".]
        `strNamespaceId` - Specifies the HL7 identifier for the user-defined table of values for this component. [Refer to User-defined Table 0363 - Assigning authority]
        `strUniversalId` - Specifies string formatted according to the scheme defined by the component, (UID type).
        `strUniversalIdType` - Specifies the interpretation of the second component of the HD.

    - #### setOriginatingReferralIdentifier

          public void setOriginatingReferralIdentifier(EI objoriginatingReferralIdentifier)

      Set the Originating Referral Identifier. This field specify the originating application's permanent identifier for the referral.
      Parameters:
        `objoriginatingReferralIdentifier` - object of originatingReferralIdentifier

    - #### setProcessDate

          public void setProcessDate(java.lang.String strTime)

      Set the Process Date. This field specify the date on which the referral originated.
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.

    - #### setProcessDate

          public void setProcessDate(DTM objprocessDate)

      Set the Process Date. This field specify the date on which the referral originated.
      Parameters:
        `strTime` - Specifies a point in time using a 24-hour clock notation.
        `objprocessDate` - object of ProcessDate

    - #### setReferralCategory

          public void setReferralCategory(java.lang.String strIdentifier,
                                 java.lang.String strText,
                                 java.lang.String strNameOfCodingSystem,
                                 java.lang.String strAlternateIdentifier,
                                 java.lang.String strAlternateText,
                                 java.lang.String strNameOfAlternateCodingSystem,
                                 java.lang.String strCodingSystemVersionID,
                                 java.lang.String strAlternateCodingSystemVersionId,
                                 java.lang.String strOriginalText,
                                 java.lang.String strSecondAlternateIdentifier,
                                 java.lang.String strSecondAlternateText,
                                 java.lang.String strNameofSecondAlternateCodingSystem,
                                 java.lang.String strSecondAlternateCodingSystemVersionID,
                                 java.lang.String strCodingSystemOID,
                                 java.lang.String strValueSetOID,
                                 java.lang.String strValueSetVersionID,
                                 java.lang.String strAlternateCodingSystemOID,
                                 java.lang.String strAlternateValueSetOID,
                                 java.lang.String strAlternateValueSetVersionID,
                                 java.lang.String strSecondAlternateCodingSystemOID,
                                 java.lang.String strSecondAlternateValueSetOID,
                                 java.lang.String strSecondAlternateValueSetVersionID)

      Set the Referral Category.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setReferralCategory

          public void setReferralCategory(CWE objreferralCategory)

      Set the Referral Category.
      Parameters:
        `objreferralCategory` - object of ReferralCategory

    - #### setReferralType

          public void setReferralType(java.lang.String strIdentifier,
                             java.lang.String strText,
                             java.lang.String strNameOfCodingSystem,
                             java.lang.String strAlternateIdentifier,
                             java.lang.String strAlternateText,
                             java.lang.String strNameOfAlternateCodingSystem,
                             java.lang.String strCodingSystemVersionID,
                             java.lang.String strAlternateCodingSystemVersionId,
                             java.lang.String strOriginalText,
                             java.lang.String strSecondAlternateIdentifier,
                             java.lang.String strSecondAlternateText,
                             java.lang.String strNameofSecondAlternateCodingSystem,
                             java.lang.String strSecondAlternateCodingSystemVersionID,
                             java.lang.String strCodingSystemOID,
                             java.lang.String strValueSetOID,
                             java.lang.String strValueSetVersionID,
                             java.lang.String strAlternateCodingSystemOID,
                             java.lang.String strAlternateValueSetOID,
                             java.lang.String strAlternateValueSetVersionID,
                             java.lang.String strSecondAlternateCodingSystemOID,
                             java.lang.String strSecondAlternateValueSetOID,
                             java.lang.String strSecondAlternateValueSetVersionID)

      Set the Referral Type.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setReferralType

          public void setReferralType(CWE objreferralType)

      Set the Referral Type.
      Parameters:
        `objreferralType` - object of ReferralType

    - #### setReferralPriority

          public void setReferralPriority(java.lang.String strIdentifier,
                                 java.lang.String strText,
                                 java.lang.String strNameOfCodingSystem,
                                 java.lang.String strAlternateIdentifier,
                                 java.lang.String strAlternateText,
                                 java.lang.String strNameOfAlternateCodingSystem,
                                 java.lang.String strCodingSystemVersionID,
                                 java.lang.String strAlternateCodingSystemVersionId,
                                 java.lang.String strOriginalText,
                                 java.lang.String strSecondAlternateIdentifier,
                                 java.lang.String strSecondAlternateText,
                                 java.lang.String strNameofSecondAlternateCodingSystem,
                                 java.lang.String strSecondAlternateCodingSystemVersionID,
                                 java.lang.String strCodingSystemOID,
                                 java.lang.String strValueSetOID,
                                 java.lang.String strValueSetVersionID,
                                 java.lang.String strAlternateCodingSystemOID,
                                 java.lang.String strAlternateValueSetOID,
                                 java.lang.String strAlternateValueSetVersionID,
                                 java.lang.String strSecondAlternateCodingSystemOID,
                                 java.lang.String strSecondAlternateValueSetOID,
                                 java.lang.String strSecondAlternateValueSetVersionID)

      Set the Referral Priority.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setReferralPriority

          public void setReferralPriority(CWE objreferralPriority)

      Set the Referral Priority.
      Parameters:
        `objreferralPriority` - object of ReferralPriority

    - #### setReferralStatus

          public void setReferralStatus(java.lang.String strIdentifier,
                               java.lang.String strText,
                               java.lang.String strNameOfCodingSystem,
                               java.lang.String strAlternateIdentifier,
                               java.lang.String strAlternateText,
                               java.lang.String strNameOfAlternateCodingSystem,
                               java.lang.String strCodingSystemVersionID,
                               java.lang.String strAlternateCodingSystemVersionId,
                               java.lang.String strOriginalText,
                               java.lang.String strSecondAlternateIdentifier,
                               java.lang.String strSecondAlternateText,
                               java.lang.String strNameofSecondAlternateCodingSystem,
                               java.lang.String strSecondAlternateCodingSystemVersionID,
                               java.lang.String strCodingSystemOID,
                               java.lang.String strValueSetOID,
                               java.lang.String strValueSetVersionID,
                               java.lang.String strAlternateCodingSystemOID,
                               java.lang.String strAlternateValueSetOID,
                               java.lang.String strAlternateValueSetVersionID,
                               java.lang.String strSecondAlternateCodingSystemOID,
                               java.lang.String strSecondAlternateValueSetOID,
                               java.lang.String strSecondAlternateValueSetVersionID)

      Set the Referral Status. This field specify the status of the referral as define by either the referred-to or the referred-by provider.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setReferralStatus

          public void setReferralStatus(CWE objreferralStatus)

      Set the Referral Status. This field specify the status of the referral as define by either the referred-to or the referred-by provider.
      Parameters:
        `objreferralStatus` - object of ReferralStatus

    - #### addReferralDisposition

          public void addReferralDisposition(java.lang.String strIdentifier,
                                    java.lang.String strText,
                                    java.lang.String strNameOfCodingSystem,
                                    java.lang.String strAlternateIdentifier,
                                    java.lang.String strAlternateText,
                                    java.lang.String strNameOfAlternateCodingSystem,
                                    java.lang.String strCodingSystemVersionID,
                                    java.lang.String strAlternateCodingSystemVersionId,
                                    java.lang.String strOriginalText,
                                    java.lang.String strSecondAlternateIdentifier,
                                    java.lang.String strSecondAlternateText,
                                    java.lang.String strNameofSecondAlternateCodingSystem,
                                    java.lang.String strSecondAlternateCodingSystemVersionID,
                                    java.lang.String strCodingSystemOID,
                                    java.lang.String strValueSetOID,
                                    java.lang.String strValueSetVersionID,
                                    java.lang.String strAlternateCodingSystemOID,
                                    java.lang.String strAlternateValueSetOID,
                                    java.lang.String strAlternateValueSetVersionID,
                                    java.lang.String strSecondAlternateCodingSystemOID,
                                    java.lang.String strSecondAlternateValueSetOID,
                                    java.lang.String strSecondAlternateValueSetVersionID)

      Set the Referral Disposition.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### addReferralDisposition

          public void addReferralDisposition(CWE objtempReferralDisposition)

      Set the Referral Disposition.
      Parameters:
        `objtempReferralDisposition` - object of ReferralDisposition

    - #### setReferralDisposition

          public void setReferralDisposition(ISingleCollection<CWE> objReferralDispositionList)

      Set the Referral Disposition list.
      Parameters:
        `objReferralDispositionList` - List of Referral Disposition.

    - #### addReferralReason

          public void addReferralReason(java.lang.String strIdentifier,
                               java.lang.String strText,
                               java.lang.String strNameOfCodingSystem,
                               java.lang.String strAlternateIdentifier,
                               java.lang.String strAlternateText,
                               java.lang.String strNameOfAlternateCodingSystem,
                               java.lang.String strCodingSystemVersionID,
                               java.lang.String strAlternateCodingSystemVersionId,
                               java.lang.String strOriginalText,
                               java.lang.String strSecondAlternateIdentifier,
                               java.lang.String strSecondAlternateText,
                               java.lang.String strNameofSecondAlternateCodingSystem,
                               java.lang.String strSecondAlternateCodingSystemVersionID,
                               java.lang.String strCodingSystemOID,
                               java.lang.String strValueSetOID,
                               java.lang.String strValueSetVersionID,
                               java.lang.String strAlternateCodingSystemOID,
                               java.lang.String strAlternateValueSetOID,
                               java.lang.String strAlternateValueSetVersionID,
                               java.lang.String strSecondAlternateCodingSystemOID,
                               java.lang.String strSecondAlternateValueSetOID,
                               java.lang.String strSecondAlternateValueSetVersionID)

      Set the Referral Reason.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### addReferralReason

          public void addReferralReason(CWE objtempReferralReason)

      Set the Referral Reason.
      Parameters:
        `objtempReferralReason` - object of ReferralReason

    - #### setReferralReason

          public void setReferralReason(ISingleCollection<CWE> objReferralReasonList)

      Set the Referral Reason list.
      Parameters:
        `objReferralDispositionList` - List of Referral Reason.

    - #### getReferralDocumentationCompletionStatus

          public CWE getReferralDocumentationCompletionStatus()

      Retrieves the Referral Documentation Completion Status. This field can be used to indicate to the receiving provider that the clinical history in the message is incomplete and that more will follow.
      Returns:
        CWE - ReferralDocumentationCompletionStatus

    - #### setReferralDocumentationCompletionStatus

          public void setReferralDocumentationCompletionStatus(java.lang.String strIdentifier,
                                                      java.lang.String strText,
                                                      java.lang.String strNameOfCodingSystem,
                                                      java.lang.String strAlternateIdentifier,
                                                      java.lang.String strAlternateText,
                                                      java.lang.String strNameOfAlternateCodingSystem,
                                                      java.lang.String strCodingSystemVersionID,
                                                      java.lang.String strAlternateCodingSystemVersionId,
                                                      java.lang.String strOriginalText,
                                                      java.lang.String strSecondAlternateIdentifier,
                                                      java.lang.String strSecondAlternateText,
                                                      java.lang.String strNameofSecondAlternateCodingSystem,
                                                      java.lang.String strSecondAlternateCodingSystemVersionID,
                                                      java.lang.String strCodingSystemOID,
                                                      java.lang.String strValueSetOID,
                                                      java.lang.String strValueSetVersionID,
                                                      java.lang.String strAlternateCodingSystemOID,
                                                      java.lang.String strAlternateValueSetOID,
                                                      java.lang.String strAlternateValueSetVersionID,
                                                      java.lang.String strSecondAlternateCodingSystemOID,
                                                      java.lang.String strSecondAlternateValueSetOID,
                                                      java.lang.String strSecondAlternateValueSetVersionID)

      Set the Referral Documentation Completion Status. This field can be used to indicate to the receiving provider that the clinical history in the message is incomplete and that more will follow.
      Parameters:
        `strIdentifier` - Specifies of characters (the code) that uniquely identifies the item being referenced.
        `strText` - Specifies The descriptive or textual name of the identifier, e.g., myocardial infarction.
        `strNameOfCodingSystem` - Identifies the coding scheme being used in the identifier component.
        `strAlternateIdentifier` - Specifies an alternate sequence of characters (the code) that uniquely identifies the item being referenced.
        `strAlternateText` - Specifies the descriptive or textual name of the alternate identifier. See usage note in section introduction.
        `strNameOfAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strCodingSystemVersionID` - A sequence of characters that uniquely identifies a second alternate code.
        `strAlternateCodingSystemVersionId` - This component carries the version for the coding system identified by components 4-6.
        `strOriginalText` - The text as seen and/or selected by the user who entered the data.
        `strSecondAlternateIdentifier` - A sequence of characters that uniquely identifies a second alternate code.
        `strSecondAlternateText` - The descriptive or textual name of the alternate identifier.
        `strNameofSecondAlternateCodingSystem` - Identifies the coding scheme being used in the alternate identifier component.
        `strSecondAlternateCodingSystemVersionID` - This component carries the version for the coding system identified by components 10-12.
        `strCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.3.
        `strValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.1 is obtained.
        `strValueSetVersionID` - This component carries the version for the value set identified by CWE.15. The version is a date. The date is the date/time that the value set being used was published.
        `strAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.6.
        `strAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.4 is obtained.
        `strAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.18. The version is a date.
        `strSecondAlternateCodingSystemOID` - This component contains the ISO Object Identifier (OID) for the coding system or value set named in CWE.12.
        `strSecondAlternateValueSetOID` - This component contains the ISO Object Identifier (OID) to allow identification of the value set from which the value in CWE.10 is obtained.
        `strSecondAlternateValueSetVersionID` - This component carries the version for the value set identified by CWE.21. The version is a date.

    - #### setReferralDocumentationCompletionStatus

          public void setReferralDocumentationCompletionStatus(CWE objReferralDocumentationCompletionStatus)

      Set the Referral Documentation Completion Status. This field can be used to indicate to the receiving provider that the clinical history in the message is incomplete and that more will follow.
      Parameters:
        `objReferralDocumentationCompletionStatus` - Object of Referral Documentation Completion Status.

    - #### getPlannedTreatmentStopDate

          public DTM getPlannedTreatmentStopDate()

      Retrieves the Planned Treatment Stop Date. The planned treatment stop date is the date that the patient's treatment from this referral is expected to complete, based on procedural protocols.
      Returns:
        DTM - PlannedTreatmentStopDate

    - #### setPlannedTreatmentStopDate

          public void setPlannedTreatmentStopDate(java.lang.String strPlannedTreatmentStopDate)

      Set the Planned Treatment Stop Date. The planned treatment stop date is the date that the patient's treatment from this referral is expected to complete, based on procedural protocols.
      Parameters:
        `strPlannedTreatmentStopDate` - String values for date that the patient's treatment from this referral is expected to complete, based on procedural protocols.

    - #### setPlannedTreatmentStopDate

          public void setPlannedTreatmentStopDate(DTM objPlannedTreatmentStopDate)

      Set the Planned Treatment Stop Date. The planned treatment stop date is the date that the patient's treatment from this referral is expected to complete, based on procedural protocols.
      Parameters:
        `objPlannedTreatmentStopDate` -

    - #### getReferralReasonText

          public ST getReferralReasonText()

      Retrieves the Referral Reason Text. The referral reason is a free text field allowing a user to capture, in a non-coded format, the reason for the referral.
      Returns:
        String - ReferralReasonText

    - #### setReferralReasonText

          public void setReferralReasonText(java.lang.String strAccidentDecription)

      Set the Referral Reason Text. The referral reason is a free text field allowing a user to capture, in a non-coded format, the reason for the referral.
      Parameters:
        `strAccidentDecription` - Used as AccidentDeathIndicator

    - #### setReferralReasonText

          public void setReferralReasonText(ST ReferralReasonText)

      Set the Referral Reason Text. The referral reason is a free text field allowing a user to capture, in a non-coded format, the reason for the referral.
      Parameters:
        `ReferralReasonText` - Used as AccidentDeathIndicator

    - #### getNumberOfAuthorizedTreatmentsUnits

          public CQ getNumberOfAuthorizedTreatmentsUnits()

      Retrieves the Number of Authorized Treatments/Units. The authorized duration is the amount of time, in days or visits, that the patient has been authorized for treatment for this referral.
      Returns:
        CQ - NumberOfAuthorizedTreatmentsUnits

    - #### setNumberOfAuthorizedTreatmentsUnits

          public void setNumberOfAuthorizedTreatmentsUnits(java.lang.String strQuantity,
                                                  CWE objUnits)

      Set the Number of Authorized Treatments/Units. The authorized duration is the amount of time, in days or visits, that the patient has been authorized for treatment for this referral.
      Parameters:
        `strQuantity` - Use as Quantity
        `objUnits` - Use as Units

    - #### setNumberOfAuthorizedTreatmentsUnits

          public void setNumberOfAuthorizedTreatmentsUnits(CQ objNumberOfAuthorizedTreatmentsUnits)

      Set the Number of Authorized Treatments/Units. The authorized duration is the amount of time, in days or visits, that the patient has been authorized for treatment for this referral.
      Parameters:
        `objNumberOfAuthorizedTreatmentsUnits` - Object of Number of Authorized Treatments/Units.

    - #### getNumberOfScheduleTreatmentsUnits

          public CQ getNumberOfScheduleTreatmentsUnits()

      Retrieves the Number of Schedule Treatments/Units. The used duration is the amount of time, in days or visits that the patient has used of the originally authorized duration.
      Returns:
        CQ - NumberOfScheduleTreatmentsUnits

    - #### setNumberOfScheduleTreatmentsUnits

          public void setNumberOfScheduleTreatmentsUnits(java.lang.String strQuantity,
                                                CWE objUnits)

      Set the Number of Schedule Treatments/Units. The used duration is the amount of time, in days or visits that the patient has used of the originally authorized duration.
      Parameters:
        `strQuantity` - Use as Quantity
        `objUnits` - Use as Units

    - #### setNumberOfScheduleTreatmentsUnits

          public void setNumberOfScheduleTreatmentsUnits(CQ objNumberOfScheduleTreatmentsUnits)

      Set the Number of Schedule Treatments/Units. The used duration is the amount of time, in days or visits that the patient has used of the originally authorized duration.
      Parameters:
        `objNumberOfScheduleTreatmentsUnits` - Object of Number of Schedule Treatments/Units.

    - #### getRemainingBenefitAmount

          public MO getRemainingBenefitAmount()

      Retrieves the Remaining Benefit Amount. The remaining benefit amount is the amount remaining from the insurance company related to this referral.
      Returns:
        MO - RemainingBenefitAmount

    - #### setRemainingBenefitAmount

          public void setRemainingBenefitAmount(java.lang.String strQuantity,
                                       java.lang.String strDenomination)

      Set the Remaining Benefit Amount. The remaining benefit amount is the amount remaining from the insurance company related to this referral.
      Parameters:
        `strQuantity` - Specifies the Quantity.
        `strDenomination` - Specifies the denomination in which the quantity is expressed.

    - #### setRemainingBenefitAmount

          public void setRemainingBenefitAmount(MO objRemainingBenefitAmount)

      Set the Remaining Benefit Amount. The remaining benefit amount is the amount remaining from the insurance company related to this referral.
      Parameters:
        `objRemainingBenefitAmount` - Object of Remaining Benefit Amount.

    - #### getAuthorizedProvider

          public XON getAuthorizedProvider()

      Retrieves the Authorized Provider. This represents the organization to which the patient was referred to perform the procedure(s).
      Returns:
        XON - AuthorizedProvider

    - #### setAuthorizedProvider

          public void setAuthorizedProvider(java.lang.String strOrganizationName,
                                   CWE objOrganizationNameTypeCode,
                                   HD objAssigningAuthority,
                                   java.lang.String strIdentifierTypeCode,
                                   HD objAssigningFacility,
                                   java.lang.String strNameRepresentationCode,
                                   java.lang.String strOrganizationIdentifier)

      Set the Authorized Provider. This represents the organization to which the patient was referred to perform the procedure(s).
      Parameters:
        `strOrganizationName` - Specifies name of the specified organization.
        `strOrganizationNameTypeCode` - Specifies a code that represents the type of name i.e., legal name, display name. Suggested Values A,L,D,SL.[Refer to table No.0204]
        `objAssigningAuthority` - Specifies The assigning authority is a unique identifier of the system (or organization or agency or department) that creates the data.
        `strIdentifierTypeCode` - Specifies a code corresponding to the type of identifier.
        `objAssigningFacility` - Specifies The place or location identifier where the identifier was first assigned to the person.
        `strNameRepresentationCode` - Specifies representations of the same name/address Suggested values are I,A,P [Refer table 0465]
        `strOrganizationIdentifier` - This component contains the sequence of characters (the code) that uniquely identifies the item being referenced by XON.1 Organization Name. This component replaces XON.3 ID Number as of v 2.5.

    - #### setAuthorizedProvider

          public void setAuthorizedProvider(XON objAuthorizedProvider)

      Ses the Authorized Provider. This represents the organization to which the patient was referred to perform the procedure(s).
      Parameters:
        `objAuthorizedProvider` - object of Authorized Provider.

    - #### getAuthorizedHealthProfessional

          public XCN getAuthorizedHealthProfessional()

      Retrieves the Authorized Health Professional. The authorized HP represents the specific health professional authorized to perform the services for the patient.
      Returns:
        XCN - AuthorizedHealthProfessional

    - #### setAuthorizedHealthProfessional

          public void setAuthorizedHealthProfessional(java.lang.String strIDNumber,
                                             FN objFamilyName,
                                             java.lang.String strGivenName,
                                             java.lang.String strSecondAndFurtherGivenNamesOrInitialsThereof,
                                             java.lang.String strSuffix,
                                             java.lang.String strPrefix,
                                             CWE objSourceTable,
                                             HD objAssigningAuthority,
                                             java.lang.String strNameTypeCode,
                                             java.lang.String strIdentifierCheckDigit,
                                             java.lang.String strCheckDigitScheme,
                                             java.lang.String strIdentifierTypeCode,
                                             HD objAssigningFacility,
                                             java.lang.String strNameRepresentationCode,
                                             CWE objNameContext,
                                             java.lang.String strNameAssemblyOrder,
                                             java.lang.String strEffectiveDate,
                                             java.lang.String strExpirationDate,
                                             java.lang.String strProfessionalSuffix,
                                             CWE objAssigningJurisdiction,
                                             CWE objAssigningAgencyOrDepratment,
                                             java.lang.String strSecurityCheck,
                                             java.lang.String strSecurityCheckScheme)

      Set the Authorized Health Professional. The authorized HP represents the specific health professional authorized to perform the services for the patient.
      Parameters:
        `strIDNumber` - Refers to the coded ID according to a user-defined table
        `objFamilyName` - Specifies the surname of a person.
        `strGivenName` - Specifies First name.
        `strSecondAndFurtherGivenNamesOrInitialsThereof` - Specifies multiple middle names that may be included by separating them with spaces.
        `strSuffix` - Used to specify a name suffix (e.g., Jr. or III).
        `strPrefix` - Used to specify a name prefix (e.g., Dr.).
        `strSourceTable` - Used as the HL7 identifier for the user-defined table of values for this component. [Refer User-defined Table 0297 - CN ID.]
        `objAssigningAuthority` - Specifies a unique identifier of the system (or organization or agency of department) that creates the data. [Refer User-defined Table 0363 - Assigning authority]
        `strNameTypeCode` - Specifies a code that represents the type of name.
        `strIdentifierCheckDigit` - Specifies part of the identifying number used in the sending application.
        `strCheckDigitScheme` - Specifies the code identifying the check digit scheme employed.[Refer HL7 Table 0061 - Check digit scheme].
        `strIdentifierTypeCode` - Specifies A code corresponding to the type of identifier.[Refer HL7 Table 0203 - Identifier type].
        `objAssigningFacility` - Specifies the place or location identifier where the identifier was first assigned to the person
        `strNameRepresentationCode` - Provides an indication of the representation provided by the data item.
        `objNameContext` - Designates the context in which a name is used. [Refer User-defined Table 03412 ]
        `strNameAssemblyOrder` - Specifies a code that represents the preferred display order of the components of this person name. Suggested values are G,F[Refer table 0444.]
        `strEffectiveDate` - Specifies the first date, if known, on which the address is valid and active.
        `strExpirationDate` - Specifies the last date, if known, on which the address is valid and active.
        `strProfessionalSuffix` - Used to specify an abbreviation, or a string of abbreviations, denoting qualifications that support the person's profession, (e.g., licenses).
        `objAssigningJurisdiction` - Specifies the geo-political body that assigned the identifier.
        `objAssigningAgencyOrDepratment` - Specifies the agency or department that assigned the identifier
        `strSecurityCheck` - Specifies the version code that may be assigned to the person identifier
        `strSecurityCheckScheme` - Specifies the check digit scheme.

    - #### setAuthorizedHealthProfessional

          public void setAuthorizedHealthProfessional(XCN objAuthorizedHealthProfessional)

      Sets the Authorized Health Professional. The authorized HP represents the specific health professional authorized to perform the services for the patient.
      Parameters:
        `objAuthorizedHealthProfessional` - object of Authorized Health Professional.

    - #### getSourceText

          public ST getSourceText()

      Retrieves the Source Text. The source text allows a user to capture information (such as the name) of the person contacted regarding the specific referral.
      Returns:
        String - SourceText

    - #### setSourceText

          public void setSourceText(java.lang.String strSourceText)

      Set the Source Text. The source text allows a user to capture information (such as the name) of the person contacted regarding the specific referral.
      Parameters:
        `strSourceText` - String value of the reason for the action indicated in the IAM-7 - Allergy Action Code field.

    - #### setSourceText

          public void setSourceText(ST objSourceText)

      Set the Source Text. The source text allows a user to capture information (such as the name) of the person contacted regarding the specific referral.
      Parameters:
        `objSourceText` - object of Source Text.

    - #### getSourceDate

          public DTM getSourceDate()

      Retrieves the Source Date. The source date allows a user to capture the date the person was contacted regarding the specific referral.
      Returns:
        DTM - SourceDate

    - #### setSourceDate

          public void setSourceDate(java.lang.String strDateTimePlannedEvent)

      Set the Source Date. The source date allows a user to capture the date the person was contacted regarding the specific referral.
      Parameters:
        `strDateTimePlannedEvent` - This field contains the date/time that the event is planned.

    - #### setSourceDate

          public void setSourceDate(DTM objSourceDate)

      Sets the Source Date. The source date allows a user to capture the date the person was contacted regarding the specific referral.
      Parameters:
        `objSourceDate` - object of Source Date.

    - #### getSourcePhone

          public XTN getSourcePhone()

      Retrieves the Source Phone. The source phone number allows a user to capture the phone number of the person contacted regarding the specific referral.
      Returns:
        XTN - Source Phone

    - #### setSourcePhone

          public void setSourcePhone(java.lang.String strTeleCommunicationUseCode,
                            java.lang.String strTeleCommunicationEquipmentType,
                            java.lang.String strCommuinicationAddress,
                            java.lang.String strCountryCode,
                            java.lang.String strAreaCityCode,
                            java.lang.String strLocalNumber,
                            java.lang.String strExtension,
                            java.lang.String strAnyText,
                            java.lang.String strExtensionPrefix,
                            java.lang.String strSpeedDialCode,
                            java.lang.String strUnformattedTelephoneNumber,
                            java.lang.String strEffectiveStartDate,
                            java.lang.String strExpirationDate,
                            CWE objExpirationReason,
                            CWE objProtectionCode,
                            EI objSharedTelecommunicationIdentifier,
                            java.lang.String strPreferenceOrder)

      Set the Source Phone. The source phone number allows a user to capture the phone number of the person contacted regarding the specific referral.
      Parameters:
        `strTeleCommunicationUseCode` - Specifies a code that represents a specific use of a telecommunication number. Suggested values are PRN,ORN,WPN,VHN,ASN,EMR,NET,BPN [Refer table 0201.]
        `strTeleCommunicationEquipmentType` - Specifies a code that represents the type of telecommunication equipment. Suggested values are PH,FX,MD,CP,BP,Internet,X.400,TDD,TTY [Refer table 0202.]
        `strCommuinicationAddress` - Specifies Email address.
        `strCountryCode` - Specifies the Country code.
        `strAreaCityCode` - Specifies the area /City Code.
        `strLocalNumber` - Specifies an Local Number.
        `strExtension` - Specifies an Extension.
        `strAnyText` - Contains comments with respect to the telephone number.
        `strExtensionPrefix` - Specifies the characters established within a company's internal telephone system network used as a prefix to the Extension component for internal dialing.
        `strSpeedDialCode` - Specifies The characters established within a company's internal telephone system used in place of the (external) telephone number.
        `strUnformattedTelephoneNumber` - Specifies an expression of the telephone number as an unparsible string.
        `strEffectiveStartDate` - Specifies start date.
        `strExpirationDate` - Specifies expiration date.
        `objExpirationReason` - Specifies reason why this contact is marked as ended.
        `objProtectionCode` - Specifies reason why this information is sensitive or protected.
        `objSharedTelecommunicationIdentifier` - Specifies a unique phone number phone telephone number or email-id.
        `strPreferenceOrder` - Specifies the preference order for an entity..

    - #### setSourcePhone

          public void setSourcePhone(XTN objXtn)

      Sets the Source Phone. The source phone number allows a user to capture the phone number of the person contacted regarding the specific referral.
      Parameters:
        `objXtn` - object of Source Phone.

    - #### getComment

          public ST getComment()

      Retrieves the Comment. The comment allows for a free text capture of any notes the user wishes to capture related to the referral.
      Returns:
        String - Comment

    - #### setComment

          public void setComment(java.lang.String strComment)

      Set the Comment. The comment allows for a free text capture of any notes the user wishes to capture related to the referral.
      Parameters:
        `strComment` - String value of the reason for the action indicated in the IAM-7 - Allergy Action Code field.

    - #### setComment

          public void setComment(ST objComment)

      Set the Comment. The comment allows for a free text capture of any notes the user wishes to capture related to the referral.
      Parameters:
        `objComment` - object of Comment.

    - #### getActionCode

          public ID getActionCode()

      Retrieves the Action Code. This field defines the action to be taken for this referral.
      Returns:
        ID - ActionCode

    - #### setActionCode

          public void setActionCode(java.lang.String strActionCode)

      Set the Action Code. This field defines the action to be taken for this referral.
      Parameters:
        `strActionCode` - Specifies indicates whether the insurance company requires a written notice of admission from the healthcare provider.[Refer to HL7 table 0136].Suggested Values Y,N.

    - #### setActionCode

          public void setActionCode(ID objActionCode)

      Set the Action Code. This field defines the action to be taken for this referral.
      Parameters:
        `objActionCode` - Specifies indicates whether the insurance company requires a written notice of admission from the healthcare provider.[Refer to HL7 table 0136].Suggested Values Y,N.